<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionModulo }}</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">
        {{ textoGestionModulo }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
            Nombre del Modulo
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="modulo.descripcion"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.moduloVuelidate.descripcion.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(modulo.descripcion, 50)
              "
              background-color="white"
            >
              <template
                v-if="$v.moduloVuelidate.descripcion.$error"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.moduloVuelidate.descripcion.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.moduloVuelidate.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
            Modulo
            <span class="tRojo">*</span>
            <br />
            <v-autocomplete
              v-model="modulo.id_modulo"
              :items="modulos"
              item-value="id_modulo"
              item-text="descripcion"
              solo
              label="Componente"
              :error="$v.moduloVuelidate.id_modulo.$error"
            >
              <template
                v-if="!$v.moduloVuelidate.id_modulo.required"
                v-slot:append-outer
              >
                <v-popover placement="bottom-end" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover"> </template>
                </v-popover>
              </template>
            </v-autocomplete>
          </v-col>
          <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
            Ouculto en menú
            <span class="tRojo">*</span>
            <br />
            <v-switch
              class="mt-1"
              inset
              v-model="modulo.oculto_menu"
            ></v-switch>
          </v-col>
        </v-row>
      </div>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingModulo },
            { 'error-validation-btn': $v.$invalid }
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="cardModulo.to"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Modulos</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionModulos",
  components: {
    LeavePage
  },
  data() {
    return {
      savingModulo: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      flujoParent: null,
      modulos: [],
      cardModulo: {
        to: {
          name: "privilegios_flujos_modulos"
        }
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Flujos",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos"
          }
        }
      ],
      moduloBackup: {
        id_flujo_modulo: null,
        id_flujo: null,
        descripcion: "",
        oculto_menu: false,
        fecha_creacion: null,
        fecha_modificacion: null
      },
      modulo: {
        id_flujo_modulo: null,
        id_flujo: null,
        descripcion: "",
        oculto_menu: false,
        fecha_creacion: null,
        fecha_modificacion: null
      },
      textoGestionModulo: null
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.moduloBackup) {
        const originalValue = JSON.stringify(this.moduloBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.modulo).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.modulo.id_flujo_modulo === undefined;
      }
    },
    moduloVuelidate() {
      let moduloVuelidate = JSON.parse(JSON.stringify(this.modulo));
      return moduloVuelidate;
    }
  },
  validations: {
    moduloVuelidate: {
      descripcion: {
        required
      },
      id_modulo: {
        required
      }
    }
  },
  methods: {
    getModulos() {
      var self = this;
      axios
        .get("/modulo/secure/get")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setModulos(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setModulos(data) {
      if (data) {
        this.modulos = data;
      }
    },
    guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.savingModulo = true;
        if (this.modulo.id_flujo_modulo) {
          axios
            .put("/modulo/flujo/secure/put", this.modulo)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.moduloBackup = JSON.parse(JSON.stringify(self.modulo));
                } else {
                  console.log("No Update");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingModulo = false;
            });
        } else {
          axios
            .post("/modulo/flujo/secure/post", this.modulo)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.moduloBackup = JSON.parse(JSON.stringify(self.modulo));
                } else {
                  console.log("No Insert");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingModulo = false;
            });
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    cancelGlobalChanges() {
      this.modulo = JSON.parse(JSON.stringify(this.moduloBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    initValues() {
      this.breadcrumbs.push({
        text: this.flujoParent.descripcion,
        disabled: true
      });
      this.breadcrumbs.push({
        text: "Modulos",
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_flujos_modulos"
        }
      });
      if (!this.modulo.id_flujo_modulo) {
        this.textoGestionModulo = "Crear un Modulo";
        this.breadcrumbs.push({
          text: "Nuevo",
          disabled: true
        });
      } else {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true
        });
        this.textoGestionModulo = "Editar un Modulo";
      }
    }
  },
  created() {
    this.getModulos();
    if (this.$route.params.flujo) {
      this.flujoParent = this.serviceCommons.base64ToObject(
        this.$route.params.flujo
      );
      this.modulo.id_flujo = this.flujoParent.id_flujo;
    }
    if (this.$route.params.modulo) {
      this.modulo = this.serviceCommons.base64ToObject(
        this.$route.params.modulo
      );
    }
    this.moduloBackup = JSON.parse(JSON.stringify(this.modulo));
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
